<template>
  <main>
    <header>
      <h1
        class="title"
      >
        Navette <em class="is-size-6">#{{ id }}</em>
      </h1>
    </header>
    <section
      class="box"
    >
      <ul>
        <li>
          Trajet : <strong>{{ shuttleFactory.label }}</strong>
        </li>
        <li
          v-for="(stop, i) in shuttleFactory.stops"
          :key="stop.id"
          class="top-stop-item"
        >
          <ul>
            <li>
              {{ displayStopType(i) }} : <strong>{{ stop.label }}</strong> le <strong>{{ displayStopTime(i) }}</strong>
            </li>
            <li class="sub-list-item">
              {{ displayInPassengers(i) }}
            </li>
            <li class="sub-list-item">
              {{ displayOutPassengers(i) }}
            </li>
          </ul>
        </li>
        <li>Chauffeur : <strong>{{ driver.firstname }} {{ driver.lastname }}</strong></li>
        <li v-if="car">
          Véhicule : <strong>{{ car.id }}</strong>
        </li>
        <li>Statut : <strong>{{ convertStatus(status) }}</strong></li>
        <li>Nombre total de passagers : <strong>{{ passengersCount }}</strong></li>
        <li v-if="comments">
          Commentaires : <strong>{{ comments }}</strong>
        </li>
        <li>Date de création : <strong>{{ createdAt }}</strong></li>
      </ul>
    </section>
  </main>
</template>

<script>
import { DateTime } from 'luxon';
import { CREATED, DELIVERED, STARTED } from '@fabnumdef/e-chauffeur_lib-vue/api/status/states';
import { CANCELED_STATUSES } from '@fabnumdef/e-chauffeur_lib-vue/api/status';

const mask = [
  'id',
  'shuttleFactory',
  'passengers',
  'driver(firstname,lastname)',
  'car(id)',
  'status',
  'createdAt',
  'comments',
];

const formatDate = (ISODate) => DateTime.fromISO(ISODate).toFormat('dd LLL yyyy à HH:mm', { locale: 'fr' });

export default {
  async asyncData({ params, $api }) {
    const { data } = await $api.query('shuttles')
      .setCampus(params.campus)
      .setMask(mask)
      .get(params.id);

    const shuttle = {
      ...data,
      createdAt: formatDate(data.createdAt),
    };
    return {
      ...shuttle,
    };
  },
  computed: {
    passengersCount() {
      const { length: activePassengerNumber } = this.passengers
        .filter((passenger) => !CANCELED_STATUSES.includes(passenger.status));
      return activePassengerNumber;
    },
  },
  methods: {
    convertStatus(status) {
      switch (status) {
        case CREATED:
          return 'Crée';
        case STARTED:
          return 'En cours';
        case DELIVERED:
          return 'Délivrée';
        default:
          return null;
      }
    },
    displayStopType(index) {
      let content = `Arrêt ${index + 1}`;
      if (index === 0) {
        content = 'Départ';
      } else if (index === this.shuttleFactory.stops.length - 1) {
        content = 'Terminus';
      }
      return content;
    },
    displayInPassengers(index) {
      const stop = this.shuttleFactory.stops[index];
      const { length: passengersInNumber } = this.passengers.filter((passenger) => passenger.departure.id === stop.id);
      return `passager${passengersInNumber ? 's' : ''} en montée : ${passengersInNumber}`;
    },
    displayOutPassengers(index) {
      const stop = this.shuttleFactory.stops[index];
      const { length: passengersOutNumber } = this.passengers.filter((passenger) => passenger.arrival.id === stop.id);
      return `passager${passengersOutNumber ? 's' : ''} en descente : ${passengersOutNumber}`;
    },
    displayStopTime(index) {
      const stop = this.shuttleFactory.stops[index];
      return formatDate(stop.time);
    },
  },
};
</script>

<style lang="scss" scoped>
h1 {
  margin-bottom: .6em;
}

.top-stop-item {
  padding-bottom: 1em;
  margin-bottom: 1em;
  border-bottom: 1px solid black;
}

.sub-list-item {
  opacity: .7;
}
</style>
